
schemes <- {}
scheme_weights <- {}

foreach (name in split(@"
  utils
  basic
  mods
  events
  places
  test
  ", " \t\r\n")) include("gen/"+name+".nut")


in_main_menu <- false


function generate_world(reason)
{
  in_main_menu=(reason=="main_menu")

  // set_rnd_seed(1234)
  reseed_noise()

  local s=choose_scheme(frnd())
  // s="sponge1"
  print(format("using world scheme '%s'\n", s))

  cur_mod=MultiModifier()
  foreach (m in modifiers)
    if (frnd()<m.chance)
    {
      print(format("  using mod '%s'\n", m.name))
      cur_mod.subs.append(m)
    }

  places=[]
  cur_mod.reset()

  local ha=frnd()*PI*2, va=rndf(-5, 30)*PI/180
  set_sun_dir(make4f(cos(ha)*cos(va), sin(va), sin(ha)*cos(va), 0))

  create_magic_places()

  schemes[s]()

  recenter_hmap()

  mark_water(0.1, MARK_WATER, 0)

  cur_mod.beforeObjects()

  local count=0
  for (local n=irnd()%800+0; n>0; --n)
    if (place_object(TreeObject(hmfrnd(), hmfrnd()))) ++count
  print(format("placed %d trees\n", count))

  if (in_main_menu)
  {
    // for (local n=20; n>0; --n)
    // {
    //   local ws=add_water_source(vec4f(hmrnd(), 0, hmrnd(), 1), 3, 5)
    //   if (ws) ws.setHidden(true)

    //   ws=add_water_source(vec4f(hmrnd(), 0, hmrnd(), 1), 3, -5)
    //   if (ws) ws.setHidden(true)
    // }

    // local dt=0.05, tt=60.0*0.5
    // for (local t=0; t<tt; t+=dt)
    // {
    //   show_splash("Simulating water", t/tt)
    //   simulate_water(dt)
    // }

    foreach (p in places)
      if (frnd()<0.5) SpellObject(p.cx, p.cz, ID_FireballSpell)
  }
  else
  {
    // SpellObject(0, 20, ID_WaterSourceSpell)
    // SpellObject(0, 20, ID_HealingSpell)
    // TreeObject(0, 20)
  }

  update_check_delay=0.0
}
